#ifndef COMMUNICATION_TCP_H
#define COMMUNICATION_TCP_H

#include <string>
#include <iostream>
#include <arpa/inet.h>
#include <unistd.h>
#include <fcntl.h>
#include <pthread.h>
#include<netinet/tcp.h>

class Communication_tcp
{

public:
	Communication_tcp();
	~Communication_tcp();

	bool communication_tcp_init();				 //创建套接字
	bool communication_tcp_bind(const char *ip,unsigned short port);  //绑定端口号
	bool communication_tcp_listen(unsigned short num = 10); //监听数量
	bool set_block(bool isblock);  //设置阻塞模式  （希望只有在connect的时候是非阻塞的，而接收数据时候是阻塞的）
	bool communication_tcp_connect(const char *ip, unsigned short port, int sec = 5);
	bool communication_tcp_connect(int sec = 5);
	Communication_tcp Accept();                   //返回Communication_tcp对象，接收连接
	void communication_tcp_uninit();							//关闭连接
	int communication_tcp_recv(char *buf, int size);          //接收数据
	int communication_tcp_send(const char *buf, int size);	//发送数据
	bool is_connected();

	int set_recv_timeout(int sec = 1);			 //设置udp接收超时
	int set_send_timeout(int sec = 1);		     //设置udp发送超时
private:
	char m_client_ip[16];						//存放接收到的client ip
	unsigned short m_client_port;			//存放接收到的client port

	char m_server_ip[16];   			//tcp_serverip 服务端ip
	int m_socket;						//tcp客户端的socket，init自动生成
	unsigned short m_server_port;		//端口
};

#endif