//
// Created by huli on 2021/12/30.
//

#include <sstream>
#include "led_outlet.h"



//更新车辆信息
void Led_outlet::update_car_information(std::string car_licence, int unit_id, int outlet_id, Outlet_car_status outlet_car_status, int m_time_remaining)
{
	auto iter = Led_outlet_show_map.begin();
	for (; iter != Led_outlet_show_map.end(); ++iter)
	{
	    if ( iter->second.m_car_licence == car_licence )
	    {
			iter->second.m_unit_id = unit_id;
			iter->second.m_outlet_id = outlet_id;
			iter->second.m_outlet_car_status = outlet_car_status;
			iter->second.m_time_remaining = m_time_remaining;
			break;
	    }
	}
	if ( iter == Led_outlet_show_map.end() )
	{
		std::chrono::system_clock::time_point t_time = std::chrono::system_clock::now();
		Led_outlet_show_map[t_time] = Outlet_car_information();
		Led_outlet_show_map[t_time].m_car_licence = car_licence;
		Led_outlet_show_map[t_time].m_unit_id = unit_id;
		Led_outlet_show_map[t_time].m_outlet_id = outlet_id;
		Led_outlet_show_map[t_time].m_outlet_car_status = outlet_car_status;
		Led_outlet_show_map[t_time].m_time_remaining = m_time_remaining;
	}
	return;
}
//更新车辆信息
void Led_outlet::update_car_information(std::string car_licence, Outlet_car_status outlet_car_status, int m_time_remaining)
{
	auto iter = Led_outlet_show_map.begin();
	for (; iter != Led_outlet_show_map.end(); ++iter)
	{
		if ( iter->second.m_car_licence == car_licence )
		{
			iter->second.m_outlet_car_status = outlet_car_status;
			iter->second.m_time_remaining = m_time_remaining;
			break;
		}
	}
	if ( iter == Led_outlet_show_map.end() )
	{
		std::chrono::system_clock::time_point t_time = std::chrono::system_clock::now();
		Led_outlet_show_map[t_time] = Outlet_car_information();
		Led_outlet_show_map[t_time].m_car_licence = car_licence;
		Led_outlet_show_map[t_time].m_outlet_car_status = outlet_car_status;
		Led_outlet_show_map[t_time].m_time_remaining = m_time_remaining;
	}
	return;
}
//是否存在此车辆信息
bool Led_outlet::is_exist_outlet_car_information(Led_outlet::Outlet_car_information outlet_car_information)
{

	for (auto iter = Led_outlet_show_map.begin();iter != Led_outlet_show_map.end(); ++iter)
	{
		if ( iter->second.m_car_licence == outlet_car_information.m_car_licence &&
				iter->second.m_outlet_id == outlet_car_information.m_outlet_id &&
				iter->second.m_unit_id == outlet_car_information.m_unit_id &&
				iter->second.m_outlet_car_status == outlet_car_information.m_outlet_car_status )
		{
			return true;
		}
	}
	return false;
}
//删除车辆信息
void Led_outlet::delete_car_information(std::string car_licence)
{
	auto iter = Led_outlet_show_map.begin();
	for (; iter != Led_outlet_show_map.end(); ++iter)
	{
		if ( iter->second.m_car_licence == car_licence )
		{
			Led_outlet_show_map.erase(iter);
		}
	}
	return;
}
std::string Led_outlet::get_show_string()
{
	std::string t_result;

	for (auto iter = Led_outlet_show_map.begin(); iter != Led_outlet_show_map.end(); ++iter)
	{
		//时间字符串
		time_t tt = std::chrono::system_clock::to_time_t(iter->first);
		tm time_tm=*localtime(&tt);
		char strTime[100] = "";
		sprintf(strTime, "%02d:%02d:%02d", time_tm.tm_hour, time_tm.tm_min, time_tm.tm_sec);
		std::string t_time_string = strTime;

		//出口
		char t_char1 = 'A' + iter->second.m_unit_id;
		char t_buf1[256];
		if ( iter->second.m_outlet_id != -1 )
		{
			sprintf(t_buf1, "%c单元 %d号出口", t_char1, iter->second.m_outlet_id);
		}
		else
		{
			sprintf(t_buf1, "%c单元       ", t_char1 );
		}

		std::string t_outlet_string = std::string(t_buf1);

		//取车状态
		std::string t_outlet_car_status_string ;
		switch ( iter->second.m_outlet_car_status )
		{
			case OUTLET_CAR_STATUS_UNKNOW:
			{
				t_outlet_car_status_string = "未知  ";
				break;
			}
			case OUTLET_CAR_STATUS_READY:
			{
				t_outlet_car_status_string = "准备中";
				break;
			}
			case OUTLET_CAR_STATUS_WORKING:
			{
				t_outlet_car_status_string = "工作中";
				break;
			}
			case OUTLET_CAR_STATUS_OVER:
			{
				t_outlet_car_status_string = "已完成";
				break;
			}
			case OUTLET_CAR_STATUS_FAULT:
			{
				t_outlet_car_status_string = "故障  ";
				break;
			}
			default:
			{
				t_outlet_car_status_string = "未知  ";
				break;
			}
		}

		//剩余时间
		char t_buf2[256];
		if ( iter->second.m_time_remaining != -1 )
		{
			sprintf(t_buf2, "剩余%d秒", iter->second.m_time_remaining);
		}
		else
		{
			sprintf(t_buf2, "剩余X秒");
		}
		std::string t_time_remaining_string = std::string(t_buf2);

		//字符串拼接
		t_result += "\\C1"+t_time_string + " "
					+ "\\C1"+iter->second.m_car_licence + " \\C1将取到 "
					+ "\\C2"+t_outlet_string + " "
					+ "\\C2"+t_outlet_car_status_string + " "
					+ "\\C4"+t_time_remaining_string + "\\n";
	}
	return t_result;
}
std::vector<std::string> Led_outlet::get_show_string_vector()
{
	//分割字符串
	//用于存放分割后的字符串
	std::vector<std::string> res;
	//获取字符串
	std::string buffer = get_show_string();
	//暂存的字符串
	std::string result;
	//将字符串读到input中

	std::stringstream input(buffer);
	//依次输出到result中，并存入res中
	while(input>>result)
	{
		res.push_back(result);
	}
	return res;
}















