
#include "notify_manage_communication.h"

Notify_manage_communication::Notify_manage_communication()
{
}

Notify_manage_communication::~Notify_manage_communication()
{
}


//************************************* 内部函数 ****************************************
//封装反馈消息自动发送
Error_manager Notify_manage_communication::encapsulate_msg(Communication_message *message)
{
	if (message == nullptr)
	{
		return Error_manager(POINTER_IS_NULL, NEGLIGIBLE_ERROR, "Notify_manage_communication::message null pointer");
	}
	//针对待发送的不同反馈消息，分别进行校核
	switch(message->get_message_type())
	{
		//取车等候答复消息
		case Communication_message::eNotify_response_msg:
		{
			break;
		}
		//取车等候区状态
		case Communication_message::eNotify_status_msg:
		{
			break;
		}
		default:
			return Error_manager(PARKSPACE_ALLOCATOR_MSG_RESPONSE_TYPE_ERROR, NEGLIGIBLE_ERROR, "Notify_manage_communication::message response type error");
	}

	//发送请求
	return Communication_socket_base::encapsulate_msg(message);
}

//封装发送消息
Error_manager Notify_manage_communication::encapsulate_msg(std::string message)
{
	return Communication_socket_base::encapsulate_msg(message);
}
//执行消息
Error_manager Notify_manage_communication::execute_msg(Communication_message *p_msg)
{
	return Notify_manager::get_instance_references().execute_msg(p_msg);
}

//检查消息是否应由本模块接收
Error_manager Notify_manage_communication::check_msg(Communication_message* p_msg)
{

	//通过 p_msg->get_message_type() 和 p_msg->get_receiver() 判断这条消息是不是车位请求消息.

	if(p_msg->get_receiver() == Communication_message::Communicator::eNotify ||
	p_msg->get_receiver() == Communication_message::Communicator::eEmpty)
	{
		switch(p_msg->get_message_type())
		{
			case Communication_message::Message_type::eDispatch_status_msg:
				return Error_code::SUCCESS;
			case Communication_message::Message_type::eNotify_request_msg:
				return Error_code::SUCCESS;
			default:
				return Error_code::INVALID_MESSAGE;
		}
	}
	return Error_code::INVALID_MESSAGE;
}
//检查执行者
Error_manager Notify_manage_communication::check_executer(Communication_message*  p_msg)
{
	//检查对应模块的状态, 判断是否可以处理这条消息
	//同时也要判断是否超时, 超时返回 COMMUNICATION_ANALYSIS_TIME_OUT
	//如果处理器正在忙别的, 那么返回 COMMUNICATION_EXCUTER_IS_BUSY

//	Error_manager t_error;
//	if ( p_msg->is_over_time() )
//	{                //huli +1
//
//		std::cout << "Notify_manage_communication...COMMUNICATION_ANALYSIS_TIME_OUT , " << std::endl;
//		//超时:接收方不做处理,发送方会进行超时处理
//		return Error_code::COMMUNICATION_ANALYSIS_TIME_OUT;
//	}
//	else
//	{
//	//	Error_manager t_error=Notify_manage::get_instance_pointer()->check_status();
//		if(t_error != SUCCESS)
//		{
//			return t_error;
//		}
//	}
	return Error_code::SUCCESS;
}

//重载心跳与车位状态发送函数
Error_manager Notify_manage_communication::encapsulate_send_data()
{
    return Error_code::SUCCESS;
}