//
// Created by zx on 2020/6/18.
//

#ifndef NOTIFY_MANAGE_COMMUNICATOR_H
#define NOTIFY_MANAGE_COMMUNICATOR_H

#include <mutex>
#include "communication_socket_base.h"
#include "singleton.h"

#include "notify_manage.h"
#include "error_code.h"

class Notify_manage_communication: public Singleton<Notify_manage_communication>, public Communication_socket_base
{
	friend Singleton<Notify_manage_communication>;

private:
	Notify_manage_communication();
public:
	virtual ~Notify_manage_communication();
	//封装反馈消息，加入队列父类自行发送
	virtual Error_manager encapsulate_msg(Communication_message* message);
	//封装发送消息
	virtual Error_manager encapsulate_msg(std::string message);
protected:

	virtual Error_manager execute_msg(Communication_message* p_msg);
	//检查是否接收到本模块需要的消息，重载后父类自行调用判断
	virtual Error_manager check_msg(Communication_message* p_msg);
	//重载检查执行者函数，判断执行者状态
	virtual Error_manager check_executer(Communication_message*  p_msg);
	//心跳与车位实时信息
	virtual Error_manager encapsulate_send_data();
};


#endif //PARKSPACE_ALLOCATION_COMMUNICATOR_H
